meal_plan/urls.py
from django.urls import path
from meal_plan.views import (
    MealPlanListView,
    MealPlanCreateView,
    MealPlanDeleteView,
    MealPlanUpdateView,
    MealPlanDetailView,
)


urlpatterns = [
    #  path("meal_plan/", include("meal_plan.urls")),
    path("", MealPlanListView.as_view(), name="meal_plan_list"),
    path("<int:pk>/", MealPlanDetailView.as_view(), name="meal_plan_detail"),
    path(
        "<int:pk>/delete/",
        MealPlanDeleteView.as_view(),
        name="meal_plan_delete",
    ),
    path("new/", MealPlanCreateView.as_view(), name="meal_plan_new"),
    path("<int:pk>/edit/", MealPlanUpdateView.as_view(), name="meal_plan_edit"),
    # path("<int:meal_plan_id>/ratings/", log_rating, name="meal_plan_rating"),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views


urlpatterns = [
    path("meal_plan/", include("meal_plan.urls")),
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDeleteView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
]

meal_plan/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


class MealPlan(models.Model):
    name = models.CharField(max_length=120)
    date = models.DateTimeField()
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="meal_plan",
        on_delete=models.CASCADE,
        null=True,
    )
    recipes = models.ManyToManyField("recipes.Recipe", related_name="meal_plan")

    def __str__(self):
        return str(self.name)

meal_plan/views.py
from django.shortcuts import render

from django.shortcuts import redirect
from django.urls import reverse_lazy

from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView

from django.contrib.auth.mixins import LoginRequiredMixin


from meal_plan.models import MealPlan


# Create your views here.
class MealPlanListView(LoginRequiredMixin, ListView):
    model = MealPlan
    template_name = "meal_plan/list.html"
    paginate_by = 3

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanDetailView(LoginRequiredMixin, DetailView):
    model = MealPlan
    template_name = "meal_plan/detail.html"

    # def get_context_data(self, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     # context["rating_form"] = RatingForm()
    #     return context

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanCreateView(LoginRequiredMixin, CreateView):
    model = MealPlan
    template_name = "meal_plan/new.html"
    fields = ["name", "date", "recipes"]
    success_url = reverse_lazy("meal_plan_list")

    # def form_valid(self, form):
    #     form.instance.author = self.request.user
    #     return super().form_valid(form)

    # def get_queryset(self):
    #     return MealPlan.objects.filter(owner=self.request.user)

    def form_valid(self, form):
        plan = form.save(commit=False)
        plan.owner = self.request.user
        plan.save()
        form.save_m2m()
        return redirect("meal_plan_detail", pk=plan.id)


class MealPlanUpdateView(LoginRequiredMixin, UpdateView):
    model = MealPlan
    template_name = "meal_plan/edit.html"
    fields = ["name", "date", "recipes"]
    success_url = reverse_lazy("meal_plan_detail")
    ##    success_url = reverse_lazy("meal_plan_detail"
    def get_success_url(self) -> str:
        return reverse_lazy("meal_plan_detail", args=[self.object.id])

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanDeleteView(LoginRequiredMixin, DeleteView):
    model = MealPlan
    template_name = "meal_plan/delete.html"
    success_url = reverse_lazy("meal_plan_list")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

meal_plan/templates/meal_plan/delete.html
{% extends 'base.html' %}
{% block content %}

  <main>
    <div class="delete-form">
      <form method="post">
        {% csrf_token %}
        <p>Are you sure you want to delete "{{ mealplan }}"?</p>
        {{ form.as_p }}
        <div>
          <button class="button">Delete</button>
        </div>
      </form>
    </div>
  </main>

  {% endblock content %}

meal_plan/templates/meal_plan/detail.html
{% extends 'base.html' %}
{% block content %}

{% load markdownify %}

  <main class="recipe-detail">
    <div>
      <a href="{% url 'meal_plan_edit' mealplan.id %}">Edit</a>
      <a href="{% url 'meal_plan_delete' mealplan.id %}">Delete</a>
    </div>

    Recipes for {{ mealplan.name }} on {{ mealplan.date }}
    {% comment %} Recipes for {{ mealplan.recipes }} on {{ mealplan.date }} {% endcomment %}

    {% comment %} <p> {% for recipe in recipes.mealplan.all %}{{ mealplan.recipes }} {% endfor %}</p> {% endcomment %}

    {% for recipe in mealplan.recipes.all %}
      <p>
        <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
      </p>
    {% endfor %}

    {% comment %} {% if recipe.image %}
      <img src="{{ recipe.image }}" class="pull-right">
    {% endif %} {% endcomment %}
    {% comment %} <h1>{{ mealplan.name }}</h1>
    <h2>by: {{ recipe.author | default_if_none:"Unknown" }}</h2>

    <p>
      Created on {{ recipe.created }} |
      Updated on {{ recipe.updated }}
    </p>
    <form method="post" action="{% url 'recipe_rating' recipe.id %}">
      {% csrf_token %}
      <div class="rating-form-grid">
        {{ rating_form.as_p }}
        <button class="button">Rate</button>
      </div>
    </form>
    <p>Tags: {% for tag in recipe.tags.all %}{{ tag.word }} {% endfor %}</p>
    {{ recipe.description | markdownify }}
    <h2>Ingredients</h2> {% endcomment %}
    {% comment %} <table>
      <thead>
        <tr>
          <th colspan="2">Amount</th>
          <th>Food item</th>
        </tr>
      </thead>
      <tbody>
        {% for ingredient in recipe.ingredients.all %}
          <tr>
            <td>{{ ingredient.amount }}</td>
            <td>{{ ingredient.measure.name }}</td>
            <td>{{ ingredient.food.name }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table> {% endcomment %}
    {% comment %} <h2>Steps</h2>
    <ol>
      {% for step in recipe.steps.all %}
        <li>{{ step.directions }}</li>
      {% endfor %}
    </ol> {% endcomment %}
  </main>
  {% endblock content %}

meal_plan/templates/meal_plan/edit.html
{% extends 'base.html' %}

{% block content %}

  <main class="recipe-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Update</button>
      </div>
    </form>
  </main>

  {% endblock content %}

meal_plan/templates/meal_plan/list.html
{% extends 'base.html' %}

{% block pagination %}
    <div class="pagination">
      <span class="step-links">
        {% if page_obj.has_previous %}
          <a href="?page=1">&laquo; first</a>
          <a href="?page={{ page_obj.previous_page_number }}">previous</a>
        {% endif %}

        <span class="current">
          Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
        </span>

        {% if page_obj.has_next %}
          <a href="?page={{ page_obj.next_page_number }}">next</a>
          <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
        {% endif %}
      </span>
    </div>
    <a href="{% url 'meal_plan_new' %}">Create</a>

    {% endblock pagination %}


    {% block content %}

  </header>
  <main class="recipe-grid">
    {% for mealplan in mealplan_list %}
      <div class="recipe-card">
        <h2 class="recipe-card-title">
          <a href="{% url 'meal_plan_detail' mealplan.pk %}">{{ mealplan.name }}</a>
        </h2>
        {% for recipe in mealplan.recipes.all %}
      <p>
        <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
      </p>
    {% endfor %}
        {% comment %} <p class="recipe-card-date">{{ mealplan.updated }}</p> {% endcomment %}
      </div>
    {% endfor %}
  </main>
  {% endblock content %}

meal_plan/templates/meal_plan/new.html
{% extends 'base.html' %}
{% block content %}

  <main class="recipe-form">
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Create</button>
      </div>
    </form>
  </main>
  {% endblock content %}